﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Paint;
using Telerik.WinControls.UI;

namespace _1006571
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();
            this.radScheduler1.ActiveViewType = SchedulerViewType.Week;
            radScheduler1.ElementProvider = new MyElementProvider(radScheduler1);
            this.radScheduler1.ActiveViewType = SchedulerViewType.Week;
            RulerPrimitive ruler = (this.radScheduler1.SchedulerElement.ViewElement as SchedulerDayViewElement).DataAreaElement.Ruler;
            ruler.CurrentTimePointerColor = Color.Red;
            //ruler.CurrentTimePointerWidth = 3;
        }
    }

    public class MyElementProvider : SchedulerElementProvider
    {
        public MyElementProvider(RadScheduler scheduler) : base(scheduler)
        {
        }

        protected override T CreateElement<T>(SchedulerView view, object context)
        {
            if (typeof(T) == typeof(DayViewAppointmentsTable))
            {
                return new MyDayViewAppointmentsTable(this.Scheduler, view, context as DayViewAppointmentsArea)as T;
            }
         
            return base.CreateElement<T>(view, context);
        }
    }
 

    class MyDayViewAppointmentsTable : DayViewAppointmentsTable
    {
        public MyDayViewAppointmentsTable(RadScheduler scheduler, SchedulerView view, DayViewAppointmentsArea area) : base(scheduler, view, area)
        {
        }

        protected override void DrawCurrentTimeIndicator(DateTime currentDateTime, SchedulerCellElement todayCell, IGraphics graphics)
        {
            TimeSpan span = currentDateTime - currentDateTime.Date.AddHours(this.GetDayViewBase().RulerStartScale).AddMinutes(this.GetDayViewBase().RulerStartScaleMinutes);
            TimeSpan hours24 = TimeSpan.FromMinutes(this.GetDayViewBase().RulerEndScale * 60 + this.GetDayViewBase().RulerEndScaleMinutes) -
                               TimeSpan.FromMinutes(this.GetDayViewBase().RulerStartScale * 60 + this.GetDayViewBase().RulerStartScaleMinutes);
 
            float p = (float)(span.TotalMinutes / hours24.TotalMinutes);
 
            float y = this.Area.Ruler.SeparatorsOffset * this.GetDayViewBase().GetRowsCount() * p;
            float x = this.Area.BoundingRectangle.X;
            float width = this.Area.BoundingRectangle.Width;
 
            y = (float)Math.Ceiling(y);
            graphics.DrawLine(this.Area.Ruler.CurrentTimePointerColor, x, y, width, y, this.Area.Ruler.CurrentTimePointerWidth);
        }
    }
}